#
# program to interpolate the source_center.dat file and prepare for stressdrop_fft.m

set range = 0/670/0/260
#set range = 0.25/19.75/0.25/19.75
set scale = 0.01i/-0.01i
#set scale = 0.1i/-0.1i
set bound = 100WSne
#set int = 0.2
set int = 1

awk '{print $1,-$2,$3}' source_center.dat > strikeslip.dat
awk '{print $1,-$2,$4}' source_center.dat > dipslip.dat

# bicubic interpolation
surface strikeslip.dat -Ginterp_strike.grd -I$int -R$range -T0 -V 
surface dipslip.dat -Ginterp_dip.grd -I$int -R$range -T0 -V 

# some values are small negative after this surface command.
# zero the negative values
grdmath interp_dip.grd 0 GE interp_dip.grd MUL = tmp.grd 
mv tmp.grd interp_dip.grd 

grdmath interp_strike.grd 0 LE interp_strike.grd MUL = tmp.grd 
mv tmp.grd interp_strike.grd 

# plotting
makecpt -Cseis -T-1000/2000/100 -I -Z > cpt2 
makecpt -Cseis -T-1000/1000/100 -I -Z > cpt1 
grdimage interp_strike.grd -Jx$scale -Ccpt1 -B$bound -K -R$range -V > strike.ps 
grdcontour interp_strike.grd -Jx -R -C100 -L-700/-1 -A100 -W2black -V -K -O >> strike.ps
psscale -D19/3.2/6.7/0.5 -B300 -Ccpt1 -O -V >> strike.ps 

grdimage interp_dip.grd -Jx -Ccpt2 -R$range -K -B$bound -V > dip.ps 
grdcontour interp_dip.grd -Jx -C100 -R -A100 -V -O -L1/2000 -W2black -K >> dip.ps
psscale -D19/3.2/6.7/0.5 -B300 -Ccpt2 -O -V >> dip.ps

rm cpt1 cpt2

grd2xyz interp_strike.grd > interp_strike.xyz 
grd2xyz interp_dip.grd > interp_dip.xyz 
awk '{print $3}' interp_dip.xyz > tmp 
paste interp_strike.xyz tmp > source_stress.dat 

rm tmp
